﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.2.4),
    on Sat Nov 12 14:35:58 2022
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.2.4'
expName = 'exp_3_prepared_enclitic_semirandom'  # from the Builder filename that created this script
expInfo = {
    'participant': '',
    'language': ['nynorsk', 'bokmål'],
    'session': ['1', '2', '3', '4'],
    'list': ['1', '2', '3', '4'],
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/jsa111/Dropbox/ForcedAlignment/Experiments/SpeechPlanningExperiments/1_Administrative/2_Experiment_files/exp_3_prepared_enclitic/exp_3_prepared_enclitic_semirandom_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# --- Setup the Window ---
win = visual.Window(
    size=[1440, 900], fullscr=True, screen=0, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = False
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}
ioSession = ioServer = eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='ptb')

# --- Initialize components for Routine "welcome" ---
welcome_header = visual.TextStim(win=win, name='welcome_header',
    text='Norsk taleproduksjon',
    font='Open Sans',
    pos=(0, 0.35), height=0.075, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
welcome_key_resp = keyboard.Keyboard()
welcome_text = visual.TextStim(win=win, name='welcome_text',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);

# --- Initialize components for Routine "instructions1" ---
instructions1_header = visual.TextStim(win=win, name='instructions1_header',
    text='',
    font='Open Sans',
    pos=(0, 0.35), height=0.075, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
instructions1_key_resp = keyboard.Keyboard()
instructions1_text = visual.TextStim(win=win, name='instructions1_text',
    text='',
    font='Open Sans',
    pos=(0, -0.1), height=0.04, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);

# --- Initialize components for Routine "instructions2" ---
instructions2_header = visual.TextStim(win=win, name='instructions2_header',
    text='Eksempel',
    font='Open Sans',
    pos=(0, 0.35), height=0.075, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
instructions2_key_resp = keyboard.Keyboard()
instructions2_text = visual.TextStim(win=win, name='instructions2_text',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);

# --- Initialize components for Routine "recording_screen" ---
recording_message = visual.TextStim(win=win, name='recording_message',
    text='START OPPTAK',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
recording_key_resp = keyboard.Keyboard()

# --- Initialize components for Routine "Practice_beep" ---
practice_start_beep = sound.Sound('1100', secs=.25, stereo=True, hamming=True,
    name='practice_start_beep')
practice_start_beep.setVolume(1.0)

# --- Initialize components for Routine "fix" ---
fixation = visual.ShapeStim(
    win=win, name='fixation', vertices='cross',
    size=(0.07, 0.07),
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)

# --- Initialize components for Routine "practice" ---
practice_stimuli = visual.TextStim(win=win, name='practice_stimuli',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
practice_question = sound.Sound('A', secs=1.0, stereo=True, hamming=True,
    name='practice_question')
practice_question.setVolume(1.0)
practice_blank_screen = visual.TextStim(win=win, name='practice_blank_screen',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
practice_beep1 = sound.Sound('1300', secs=.245, stereo=True, hamming=True,
    name='practice_beep1')
practice_beep1.setVolume(1.0)
practice_beep2 = sound.Sound('1300', secs=.245, stereo=True, hamming=True,
    name='practice_beep2')
practice_beep2.setVolume(1.0)
practice_beep3 = sound.Sound('A', secs=.245, stereo=True, hamming=True,
    name='practice_beep3')
practice_beep3.setVolume(1.0)
practice_pause_key = keyboard.Keyboard()

# --- Initialize components for Routine "practice_pause" ---
practice_pause_text = visual.TextStim(win=win, name='practice_pause_text',
    text='Du har trykt på pause, trykk på MELLOMSROMSTASTEN igjen for å fortsette',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
end_practice_pause_key = keyboard.Keyboard()

# --- Initialize components for Routine "practice_end" ---
practice_end_text = visual.TextStim(win=win, name='practice_end_text',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
practice_end_key_resp = keyboard.Keyboard()

# --- Initialize components for Routine "test_start" ---
test_start_beep = sound.Sound('1750', secs=.25, stereo=True, hamming=True,
    name='test_start_beep')
test_start_beep.setVolume(1.0)

# --- Initialize components for Routine "fix" ---
fixation = visual.ShapeStim(
    win=win, name='fixation', vertices='cross',
    size=(0.07, 0.07),
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)

# --- Initialize components for Routine "trial" ---
stimuli = visual.TextStim(win=win, name='stimuli',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
prompt = sound.Sound('A', secs=1.0, stereo=True, hamming=True,
    name='prompt')
prompt.setVolume(1.0)
blank = visual.TextStim(win=win, name='blank',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
test_beep1 = sound.Sound('1300', secs=.245, stereo=True, hamming=True,
    name='test_beep1')
test_beep1.setVolume(1.0)
test_beep2 = sound.Sound('1300', secs=.245, stereo=True, hamming=True,
    name='test_beep2')
test_beep2.setVolume(1.0)
test_beep3 = sound.Sound('A', secs=.245, stereo=True, hamming=True,
    name='test_beep3')
test_beep3.setVolume(1.0)
test_pause_key = keyboard.Keyboard()

# --- Initialize components for Routine "test_pause" ---
test_pause_text = visual.TextStim(win=win, name='test_pause_text',
    text='Du har trykt på pause, trykk på MELLOMSROMSTASTEN igjen for å fortsette',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
end_test_pause_key = keyboard.Keyboard()

# --- Initialize components for Routine "rest" ---
# Run 'Begin Experiment' code from rest_code
#trialCount=0
#breakTrials = [12,25,38,51,64,77,90,103,116,129,142,155,168,181]

rest_text = visual.TextStim(win=win, name='rest_text',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
rest_key_resp = keyboard.Keyboard()

# --- Initialize components for Routine "end" ---
end_text = visual.TextStim(win=win, name='end_text',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
end_key_resp = keyboard.Keyboard()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "welcome" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
# Run 'Begin Routine' code from welcome_code
welcome_text.alignText='left'

if expInfo['language'] == 'nynorsk': 
     welcome_message = 'I dette eksperimentet skal du uttale ei rekke forskjellege ord.\n\nEksperimentet er samansett av to delar: ei øvingsfase og ei testfase.\n\n(Trykk på MELLOMROMSTASTEN for å fortsette med instruksjonane)'
elif  expInfo['language'] == 'bokmål':
     welcome_message = 'I dette eksperimentet skal du uttale en rekke forskjellige ord.\n\nEksperimentet er sammensatt av to deler: en øvelsesfase og en testfase.\n\n(Trykk på MELLOMROMSTASTEN for å fortsette med instruksjonene)'
welcome_key_resp.keys = []
welcome_key_resp.rt = []
_welcome_key_resp_allKeys = []
welcome_text.setText(welcome_message
)
# keep track of which components have finished
welcomeComponents = [welcome_header, welcome_key_resp, welcome_text]
for thisComponent in welcomeComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "welcome" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *welcome_header* updates
    if welcome_header.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        welcome_header.frameNStart = frameN  # exact frame index
        welcome_header.tStart = t  # local t and not account for scr refresh
        welcome_header.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(welcome_header, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'welcome_header.started')
        welcome_header.setAutoDraw(True)
    
    # *welcome_key_resp* updates
    waitOnFlip = False
    if welcome_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        welcome_key_resp.frameNStart = frameN  # exact frame index
        welcome_key_resp.tStart = t  # local t and not account for scr refresh
        welcome_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(welcome_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'welcome_key_resp.started')
        welcome_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(welcome_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(welcome_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if welcome_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = welcome_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _welcome_key_resp_allKeys.extend(theseKeys)
        if len(_welcome_key_resp_allKeys):
            welcome_key_resp.keys = _welcome_key_resp_allKeys[-1].name  # just the last key pressed
            welcome_key_resp.rt = _welcome_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # *welcome_text* updates
    if welcome_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        welcome_text.frameNStart = frameN  # exact frame index
        welcome_text.tStart = t  # local t and not account for scr refresh
        welcome_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(welcome_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'welcome_text.started')
        welcome_text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in welcomeComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "welcome" ---
for thisComponent in welcomeComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if welcome_key_resp.keys in ['', [], None]:  # No response was made
    welcome_key_resp.keys = None
thisExp.addData('welcome_key_resp.keys',welcome_key_resp.keys)
if welcome_key_resp.keys != None:  # we had a response
    thisExp.addData('welcome_key_resp.rt', welcome_key_resp.rt)
thisExp.nextEntry()
# the Routine "welcome" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "instructions1" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
# Run 'Begin Routine' code from instructions1_code
instructions1_text.alignText='left'

if expInfo['language'] == 'nynorsk': 
     instructions1_head_text = 'Instruksar'
     instructions1_message = '1. Eit kvitt kors makerer midten av skjermen. Fokuser på dette korset.\n\n2. Du kjem til å sjå eitt eller to ord (t.d. \'kakao\')\n\n3. Så høyrer du eit spørsmål -- t.d. \'Kva er dyrt?\'\n\n4. Deretter høyrer du 3 pip.\n\n5. Etter det tredje pipet svarer du i di eiga dialekt med så naturleg uttale som mogleg: \'Kakao er dyrt\'. Svar så raskt som mogleg etter du høyrer det tredje pipet.\n\nTrykk på MELLOMROMSTASTEN for å fortsette med instruksjonane)'
elif  expInfo['language'] == 'bokmål':
     instructions1_head_text = 'Instrukser'
     instructions1_message = '1. Et hvitt kors makerer midten av skjermen. Fokuser på dette korset.\n\n2. Du kommer til å se ett eller to ord (f.eks. \'kakao\')\n\n3. Så hører du et spørsmål -- f.eks. \'Hva er dyrt?\'\n\n4. Deretter hører du 3 pip.\n\n5. Etter det tredje pipet svarer du i din egen dialekt med så naturlig uttale som mulig: \'Kakao er dyrt\'. Svar så raskt som mulig etter du hører det tredje pipet.\n\nTrykk på MELLOMROMSTASTEN for å fortsette med instruksjonene)'
instructions1_header.setText(instructions1_head_text)
instructions1_key_resp.keys = []
instructions1_key_resp.rt = []
_instructions1_key_resp_allKeys = []
instructions1_text.setText(instructions1_message
)
# keep track of which components have finished
instructions1Components = [instructions1_header, instructions1_key_resp, instructions1_text]
for thisComponent in instructions1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "instructions1" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instructions1_header* updates
    if instructions1_header.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions1_header.frameNStart = frameN  # exact frame index
        instructions1_header.tStart = t  # local t and not account for scr refresh
        instructions1_header.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions1_header, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions1_header.started')
        instructions1_header.setAutoDraw(True)
    
    # *instructions1_key_resp* updates
    waitOnFlip = False
    if instructions1_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions1_key_resp.frameNStart = frameN  # exact frame index
        instructions1_key_resp.tStart = t  # local t and not account for scr refresh
        instructions1_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions1_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions1_key_resp.started')
        instructions1_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(instructions1_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(instructions1_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if instructions1_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = instructions1_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _instructions1_key_resp_allKeys.extend(theseKeys)
        if len(_instructions1_key_resp_allKeys):
            instructions1_key_resp.keys = _instructions1_key_resp_allKeys[-1].name  # just the last key pressed
            instructions1_key_resp.rt = _instructions1_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # *instructions1_text* updates
    if instructions1_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions1_text.frameNStart = frameN  # exact frame index
        instructions1_text.tStart = t  # local t and not account for scr refresh
        instructions1_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions1_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions1_text.started')
        instructions1_text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructions1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "instructions1" ---
for thisComponent in instructions1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if instructions1_key_resp.keys in ['', [], None]:  # No response was made
    instructions1_key_resp.keys = None
thisExp.addData('instructions1_key_resp.keys',instructions1_key_resp.keys)
if instructions1_key_resp.keys != None:  # we had a response
    thisExp.addData('instructions1_key_resp.rt', instructions1_key_resp.rt)
thisExp.nextEntry()
# the Routine "instructions1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "instructions2" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
# Run 'Begin Routine' code from instructions2_code
instructions2_text.alignText='left'

if expInfo['language'] == 'nynorsk':
    instructions2_message = '1. Du ser: \'kakao\'\n\n2. Du høyrer: \'Kva er dyrt?\'\n\n3. Pip #1...#2...#3\n\nSvar: \'Kakao er dyrt\' så raskt men så naturleg som mogleg etter det tredje pipet\n\n(Trykk på MELLOMROMSTASTEN for å fortsette med øvingsfasen)'
elif expInfo['language'] == 'bokmål':
    instructions2_message = '1. Du ser: \'kakao\'\n\n2. Du hører: \'Hva er dyrt?\'\n\n3. Pip #1...#2...#3\n\nSvar: \'Kakao er dyrt\' så raskt men så naturlig som mulig etter det tredje pipet\n\n(Trykk på MELLOMROMSTASTEN for å fortsette med øvelsesfasen)'
instructions2_key_resp.keys = []
instructions2_key_resp.rt = []
_instructions2_key_resp_allKeys = []
instructions2_text.setText(instructions2_message)
# keep track of which components have finished
instructions2Components = [instructions2_header, instructions2_key_resp, instructions2_text]
for thisComponent in instructions2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "instructions2" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instructions2_header* updates
    if instructions2_header.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions2_header.frameNStart = frameN  # exact frame index
        instructions2_header.tStart = t  # local t and not account for scr refresh
        instructions2_header.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions2_header, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions2_header.started')
        instructions2_header.setAutoDraw(True)
    
    # *instructions2_key_resp* updates
    waitOnFlip = False
    if instructions2_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions2_key_resp.frameNStart = frameN  # exact frame index
        instructions2_key_resp.tStart = t  # local t and not account for scr refresh
        instructions2_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions2_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions2_key_resp.started')
        instructions2_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(instructions2_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(instructions2_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if instructions2_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = instructions2_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _instructions2_key_resp_allKeys.extend(theseKeys)
        if len(_instructions2_key_resp_allKeys):
            instructions2_key_resp.keys = _instructions2_key_resp_allKeys[-1].name  # just the last key pressed
            instructions2_key_resp.rt = _instructions2_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # *instructions2_text* updates
    if instructions2_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions2_text.frameNStart = frameN  # exact frame index
        instructions2_text.tStart = t  # local t and not account for scr refresh
        instructions2_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions2_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'instructions2_text.started')
        instructions2_text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructions2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "instructions2" ---
for thisComponent in instructions2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if instructions2_key_resp.keys in ['', [], None]:  # No response was made
    instructions2_key_resp.keys = None
thisExp.addData('instructions2_key_resp.keys',instructions2_key_resp.keys)
if instructions2_key_resp.keys != None:  # we had a response
    thisExp.addData('instructions2_key_resp.rt', instructions2_key_resp.rt)
thisExp.nextEntry()
# the Routine "instructions2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "recording_screen" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
recording_key_resp.keys = []
recording_key_resp.rt = []
_recording_key_resp_allKeys = []
# keep track of which components have finished
recording_screenComponents = [recording_message, recording_key_resp]
for thisComponent in recording_screenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "recording_screen" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *recording_message* updates
    if recording_message.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        recording_message.frameNStart = frameN  # exact frame index
        recording_message.tStart = t  # local t and not account for scr refresh
        recording_message.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(recording_message, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'recording_message.started')
        recording_message.setAutoDraw(True)
    
    # *recording_key_resp* updates
    waitOnFlip = False
    if recording_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        recording_key_resp.frameNStart = frameN  # exact frame index
        recording_key_resp.tStart = t  # local t and not account for scr refresh
        recording_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(recording_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'recording_key_resp.started')
        recording_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(recording_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(recording_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if recording_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = recording_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _recording_key_resp_allKeys.extend(theseKeys)
        if len(_recording_key_resp_allKeys):
            recording_key_resp.keys = _recording_key_resp_allKeys[-1].name  # just the last key pressed
            recording_key_resp.rt = _recording_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in recording_screenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "recording_screen" ---
for thisComponent in recording_screenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if recording_key_resp.keys in ['', [], None]:  # No response was made
    recording_key_resp.keys = None
thisExp.addData('recording_key_resp.keys',recording_key_resp.keys)
if recording_key_resp.keys != None:  # we had a response
    thisExp.addData('recording_key_resp.rt', recording_key_resp.rt)
thisExp.nextEntry()
# the Routine "recording_screen" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "Practice_beep" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
practice_start_beep.setSound('1100', secs=.25, hamming=True)
practice_start_beep.setVolume(1.0, log=False)
# keep track of which components have finished
Practice_beepComponents = [practice_start_beep]
for thisComponent in Practice_beepComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "Practice_beep" ---
while continueRoutine and routineTimer.getTime() < 0.25:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    # start/stop practice_start_beep
    if practice_start_beep.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        practice_start_beep.frameNStart = frameN  # exact frame index
        practice_start_beep.tStart = t  # local t and not account for scr refresh
        practice_start_beep.tStartRefresh = tThisFlipGlobal  # on global time
        # add timestamp to datafile
        thisExp.addData('practice_start_beep.started', tThisFlipGlobal)
        practice_start_beep.play(when=win)  # sync with win flip
    if practice_start_beep.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > practice_start_beep.tStartRefresh + .25-frameTolerance:
            # keep track of stop time/frame for later
            practice_start_beep.tStop = t  # not accounting for scr refresh
            practice_start_beep.frameNStop = frameN  # exact frame index
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'practice_start_beep.stopped')
            practice_start_beep.stop()
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Practice_beepComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "Practice_beep" ---
for thisComponent in Practice_beepComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
practice_start_beep.stop()  # ensure sound has stopped at end of routine
# using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
if routineForceEnded:
    routineTimer.reset()
else:
    routineTimer.addTime(-0.250000)

# set up handler to look after randomisation of conditions etc
practice_trials = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('spreadsheets/practice_stimuli.xlsx'),
    seed=None, name='practice_trials')
thisExp.addLoop(practice_trials)  # add the loop to the experiment
thisPractice_trial = practice_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisPractice_trial.rgb)
if thisPractice_trial != None:
    for paramName in thisPractice_trial:
        exec('{} = thisPractice_trial[paramName]'.format(paramName))

for thisPractice_trial in practice_trials:
    currentLoop = practice_trials
    # abbreviate parameter names if possible (e.g. rgb = thisPractice_trial.rgb)
    if thisPractice_trial != None:
        for paramName in thisPractice_trial:
            exec('{} = thisPractice_trial[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    practice_repeat = data.TrialHandler(nReps=100.0, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='practice_repeat')
    thisExp.addLoop(practice_repeat)  # add the loop to the experiment
    thisPractice_repeat = practice_repeat.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisPractice_repeat.rgb)
    if thisPractice_repeat != None:
        for paramName in thisPractice_repeat:
            exec('{} = thisPractice_repeat[paramName]'.format(paramName))
    
    for thisPractice_repeat in practice_repeat:
        currentLoop = practice_repeat
        # abbreviate parameter names if possible (e.g. rgb = thisPractice_repeat.rgb)
        if thisPractice_repeat != None:
            for paramName in thisPractice_repeat:
                exec('{} = thisPractice_repeat[paramName]'.format(paramName))
        
        # --- Prepare to start Routine "fix" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        # keep track of which components have finished
        fixComponents = [fixation]
        for thisComponent in fixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "fix" ---
        while continueRoutine and routineTimer.getTime() < 1.0:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation* updates
            if fixation.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation.frameNStart = frameN  # exact frame index
                fixation.tStart = t  # local t and not account for scr refresh
                fixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'fixation.started')
                fixation.setAutoDraw(True)
            if fixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fixation.tStartRefresh + .5-frameTolerance:
                    # keep track of stop time/frame for later
                    fixation.tStop = t  # not accounting for scr refresh
                    fixation.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'fixation.stopped')
                    fixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in fixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "fix" ---
        for thisComponent in fixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
        if routineForceEnded:
            routineTimer.reset()
        else:
            routineTimer.addTime(-1.000000)
        
        # --- Prepare to start Routine "practice" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        # Run 'Begin Routine' code from practice_code
        if expInfo['language'] == 'nynorsk': 
             Stim = nynorsk
        elif  expInfo['language'] == 'bokmål':
             Stim = bokmaal
        practice_stimuli.setText(Stim)
        practice_question.setSound(question, secs=1.0, hamming=True)
        practice_question.setVolume(1.0, log=False)
        practice_beep1.setSound('1300', secs=.245, hamming=True)
        practice_beep1.setVolume(1.0, log=False)
        practice_beep2.setSound('1300', secs=.245, hamming=True)
        practice_beep2.setVolume(1.0, log=False)
        practice_beep3.setSound('1500', secs=.245, hamming=True)
        practice_beep3.setVolume(1.0, log=False)
        practice_pause_key.keys = []
        practice_pause_key.rt = []
        _practice_pause_key_allKeys = []
        # keep track of which components have finished
        practiceComponents = [practice_stimuli, practice_question, practice_blank_screen, practice_beep1, practice_beep2, practice_beep3, practice_pause_key]
        for thisComponent in practiceComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "practice" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *practice_stimuli* updates
            if practice_stimuli.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                practice_stimuli.frameNStart = frameN  # exact frame index
                practice_stimuli.tStart = t  # local t and not account for scr refresh
                practice_stimuli.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(practice_stimuli, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'practice_stimuli.started')
                practice_stimuli.setAutoDraw(True)
            if practice_stimuli.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_stimuli.tStartRefresh + .5-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_stimuli.tStop = t  # not accounting for scr refresh
                    practice_stimuli.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_stimuli.stopped')
                    practice_stimuli.setAutoDraw(False)
            # start/stop practice_question
            if practice_question.status == NOT_STARTED and tThisFlip >= .5-frameTolerance:
                # keep track of start time/frame for later
                practice_question.frameNStart = frameN  # exact frame index
                practice_question.tStart = t  # local t and not account for scr refresh
                practice_question.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('practice_question.started', tThisFlipGlobal)
                practice_question.play(when=win)  # sync with win flip
            if practice_question.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_question.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_question.tStop = t  # not accounting for scr refresh
                    practice_question.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_question.stopped')
                    practice_question.stop()
            
            # *practice_blank_screen* updates
            if practice_blank_screen.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                # keep track of start time/frame for later
                practice_blank_screen.frameNStart = frameN  # exact frame index
                practice_blank_screen.tStart = t  # local t and not account for scr refresh
                practice_blank_screen.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(practice_blank_screen, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'practice_blank_screen.started')
                practice_blank_screen.setAutoDraw(True)
            if practice_blank_screen.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_blank_screen.tStartRefresh + 5-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_blank_screen.tStop = t  # not accounting for scr refresh
                    practice_blank_screen.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_blank_screen.stopped')
                    practice_blank_screen.setAutoDraw(False)
            # start/stop practice_beep1
            if practice_beep1.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                # keep track of start time/frame for later
                practice_beep1.frameNStart = frameN  # exact frame index
                practice_beep1.tStart = t  # local t and not account for scr refresh
                practice_beep1.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('practice_beep1.started', tThisFlipGlobal)
                practice_beep1.play(when=win)  # sync with win flip
            if practice_beep1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_beep1.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_beep1.tStop = t  # not accounting for scr refresh
                    practice_beep1.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_beep1.stopped')
                    practice_beep1.stop()
            # start/stop practice_beep2
            if practice_beep2.status == NOT_STARTED and tThisFlip >= 3.5-frameTolerance:
                # keep track of start time/frame for later
                practice_beep2.frameNStart = frameN  # exact frame index
                practice_beep2.tStart = t  # local t and not account for scr refresh
                practice_beep2.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('practice_beep2.started', tThisFlipGlobal)
                practice_beep2.play(when=win)  # sync with win flip
            if practice_beep2.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_beep2.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_beep2.tStop = t  # not accounting for scr refresh
                    practice_beep2.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_beep2.stopped')
                    practice_beep2.stop()
            # start/stop practice_beep3
            if practice_beep3.status == NOT_STARTED and tThisFlip >= Latency_s-frameTolerance:
                # keep track of start time/frame for later
                practice_beep3.frameNStart = frameN  # exact frame index
                practice_beep3.tStart = t  # local t and not account for scr refresh
                practice_beep3.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('practice_beep3.started', tThisFlipGlobal)
                practice_beep3.play(when=win)  # sync with win flip
            if practice_beep3.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_beep3.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_beep3.tStop = t  # not accounting for scr refresh
                    practice_beep3.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_beep3.stopped')
                    practice_beep3.stop()
            
            # *practice_pause_key* updates
            waitOnFlip = False
            if practice_pause_key.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                practice_pause_key.frameNStart = frameN  # exact frame index
                practice_pause_key.tStart = t  # local t and not account for scr refresh
                practice_pause_key.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(practice_pause_key, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'practice_pause_key.started')
                practice_pause_key.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(practice_pause_key.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(practice_pause_key.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if practice_pause_key.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > practice_pause_key.tStartRefresh + 6.5-frameTolerance:
                    # keep track of stop time/frame for later
                    practice_pause_key.tStop = t  # not accounting for scr refresh
                    practice_pause_key.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'practice_pause_key.stopped')
                    practice_pause_key.status = FINISHED
            if practice_pause_key.status == STARTED and not waitOnFlip:
                theseKeys = practice_pause_key.getKeys(keyList=['space'], waitRelease=False)
                _practice_pause_key_allKeys.extend(theseKeys)
                if len(_practice_pause_key_allKeys):
                    practice_pause_key.keys = _practice_pause_key_allKeys[-1].name  # just the last key pressed
                    practice_pause_key.rt = _practice_pause_key_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in practiceComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "practice" ---
        for thisComponent in practiceComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        practice_question.stop()  # ensure sound has stopped at end of routine
        practice_beep1.stop()  # ensure sound has stopped at end of routine
        practice_beep2.stop()  # ensure sound has stopped at end of routine
        practice_beep3.stop()  # ensure sound has stopped at end of routine
        # check responses
        if practice_pause_key.keys in ['', [], None]:  # No response was made
            practice_pause_key.keys = None
        practice_repeat.addData('practice_pause_key.keys',practice_pause_key.keys)
        if practice_pause_key.keys != None:  # we had a response
            practice_repeat.addData('practice_pause_key.rt', practice_pause_key.rt)
        # the Routine "practice" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "practice_pause" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        end_practice_pause_key.keys = []
        end_practice_pause_key.rt = []
        _end_practice_pause_key_allKeys = []
        # Run 'Begin Routine' code from practice_pause_code
        if not practice_pause_key.rt:
            continueRoutine = False
            practice_repeat.finished = True
        # keep track of which components have finished
        practice_pauseComponents = [practice_pause_text, end_practice_pause_key]
        for thisComponent in practice_pauseComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "practice_pause" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *practice_pause_text* updates
            if practice_pause_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                practice_pause_text.frameNStart = frameN  # exact frame index
                practice_pause_text.tStart = t  # local t and not account for scr refresh
                practice_pause_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(practice_pause_text, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'practice_pause_text.started')
                practice_pause_text.setAutoDraw(True)
            
            # *end_practice_pause_key* updates
            waitOnFlip = False
            if end_practice_pause_key.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                end_practice_pause_key.frameNStart = frameN  # exact frame index
                end_practice_pause_key.tStart = t  # local t and not account for scr refresh
                end_practice_pause_key.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(end_practice_pause_key, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'end_practice_pause_key.started')
                end_practice_pause_key.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(end_practice_pause_key.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(end_practice_pause_key.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if end_practice_pause_key.status == STARTED and not waitOnFlip:
                theseKeys = end_practice_pause_key.getKeys(keyList=['space'], waitRelease=False)
                _end_practice_pause_key_allKeys.extend(theseKeys)
                if len(_end_practice_pause_key_allKeys):
                    end_practice_pause_key.keys = _end_practice_pause_key_allKeys[-1].name  # just the last key pressed
                    end_practice_pause_key.rt = _end_practice_pause_key_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in practice_pauseComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "practice_pause" ---
        for thisComponent in practice_pauseComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if end_practice_pause_key.keys in ['', [], None]:  # No response was made
            end_practice_pause_key.keys = None
        practice_repeat.addData('end_practice_pause_key.keys',end_practice_pause_key.keys)
        if end_practice_pause_key.keys != None:  # we had a response
            practice_repeat.addData('end_practice_pause_key.rt', end_practice_pause_key.rt)
        # the Routine "practice_pause" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
    # completed 100.0 repeats of 'practice_repeat'
    
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'practice_trials'


# --- Prepare to start Routine "practice_end" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
# Run 'Begin Routine' code from practice_end_code
if expInfo['language'] == 'nynorsk':
    practice_end_message = 'Trykk på MELLOMROMSTASTEN viss alt er klart og du er klar til å fortsette til eksperimentet'
elif expInfo['language'] == 'bokmål':
    practice_end_message = 'Trykk på MELLOMROMSTASTEN hvis alt er klart og du er klar til å fortsette til eksperimentet'
practice_end_text.setText(practice_end_message)
practice_end_key_resp.keys = []
practice_end_key_resp.rt = []
_practice_end_key_resp_allKeys = []
# keep track of which components have finished
practice_endComponents = [practice_end_text, practice_end_key_resp]
for thisComponent in practice_endComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "practice_end" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *practice_end_text* updates
    if practice_end_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        practice_end_text.frameNStart = frameN  # exact frame index
        practice_end_text.tStart = t  # local t and not account for scr refresh
        practice_end_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(practice_end_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'practice_end_text.started')
        practice_end_text.setAutoDraw(True)
    
    # *practice_end_key_resp* updates
    waitOnFlip = False
    if practice_end_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        practice_end_key_resp.frameNStart = frameN  # exact frame index
        practice_end_key_resp.tStart = t  # local t and not account for scr refresh
        practice_end_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(practice_end_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'practice_end_key_resp.started')
        practice_end_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(practice_end_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(practice_end_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if practice_end_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = practice_end_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _practice_end_key_resp_allKeys.extend(theseKeys)
        if len(_practice_end_key_resp_allKeys):
            practice_end_key_resp.keys = _practice_end_key_resp_allKeys[-1].name  # just the last key pressed
            practice_end_key_resp.rt = _practice_end_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in practice_endComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "practice_end" ---
for thisComponent in practice_endComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if practice_end_key_resp.keys in ['', [], None]:  # No response was made
    practice_end_key_resp.keys = None
thisExp.addData('practice_end_key_resp.keys',practice_end_key_resp.keys)
if practice_end_key_resp.keys != None:  # we had a response
    thisExp.addData('practice_end_key_resp.rt', practice_end_key_resp.rt)
thisExp.nextEntry()
# the Routine "practice_end" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "test_start" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
test_start_beep.setSound('1750', secs=.25, hamming=True)
test_start_beep.setVolume(1.0, log=False)
# keep track of which components have finished
test_startComponents = [test_start_beep]
for thisComponent in test_startComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "test_start" ---
while continueRoutine and routineTimer.getTime() < 0.25:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    # start/stop test_start_beep
    if test_start_beep.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        test_start_beep.frameNStart = frameN  # exact frame index
        test_start_beep.tStart = t  # local t and not account for scr refresh
        test_start_beep.tStartRefresh = tThisFlipGlobal  # on global time
        # add timestamp to datafile
        thisExp.addData('test_start_beep.started', tThisFlipGlobal)
        test_start_beep.play(when=win)  # sync with win flip
    if test_start_beep.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > test_start_beep.tStartRefresh + .25-frameTolerance:
            # keep track of stop time/frame for later
            test_start_beep.tStop = t  # not accounting for scr refresh
            test_start_beep.frameNStop = frameN  # exact frame index
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'test_start_beep.stopped')
            test_start_beep.stop()
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in test_startComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "test_start" ---
for thisComponent in test_startComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
test_start_beep.stop()  # ensure sound has stopped at end of routine
# using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
if routineForceEnded:
    routineTimer.reset()
else:
    routineTimer.addTime(-0.250000)

# set up handler to look after randomisation of conditions etc
test_trials = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions("spreadsheets/list"+expInfo["list"]+"_semirandom.xlsx"),
    seed=None, name='test_trials')
thisExp.addLoop(test_trials)  # add the loop to the experiment
thisTest_trial = test_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTest_trial.rgb)
if thisTest_trial != None:
    for paramName in thisTest_trial:
        exec('{} = thisTest_trial[paramName]'.format(paramName))

for thisTest_trial in test_trials:
    currentLoop = test_trials
    # abbreviate parameter names if possible (e.g. rgb = thisTest_trial.rgb)
    if thisTest_trial != None:
        for paramName in thisTest_trial:
            exec('{} = thisTest_trial[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    test_repeat = data.TrialHandler(nReps=100.0, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='test_repeat')
    thisExp.addLoop(test_repeat)  # add the loop to the experiment
    thisTest_repeat = test_repeat.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTest_repeat.rgb)
    if thisTest_repeat != None:
        for paramName in thisTest_repeat:
            exec('{} = thisTest_repeat[paramName]'.format(paramName))
    
    for thisTest_repeat in test_repeat:
        currentLoop = test_repeat
        # abbreviate parameter names if possible (e.g. rgb = thisTest_repeat.rgb)
        if thisTest_repeat != None:
            for paramName in thisTest_repeat:
                exec('{} = thisTest_repeat[paramName]'.format(paramName))
        
        # --- Prepare to start Routine "fix" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        # keep track of which components have finished
        fixComponents = [fixation]
        for thisComponent in fixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "fix" ---
        while continueRoutine and routineTimer.getTime() < 1.0:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation* updates
            if fixation.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation.frameNStart = frameN  # exact frame index
                fixation.tStart = t  # local t and not account for scr refresh
                fixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'fixation.started')
                fixation.setAutoDraw(True)
            if fixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fixation.tStartRefresh + .5-frameTolerance:
                    # keep track of stop time/frame for later
                    fixation.tStop = t  # not accounting for scr refresh
                    fixation.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'fixation.stopped')
                    fixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in fixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "fix" ---
        for thisComponent in fixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
        if routineForceEnded:
            routineTimer.reset()
        else:
            routineTimer.addTime(-1.000000)
        
        # --- Prepare to start Routine "trial" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        # Run 'Begin Routine' code from trial_code
        if expInfo['language'] == 'nynorsk': 
             Stim = nynorsk
        elif  expInfo['language'] == 'bokmål':
             Stim = bokmaal
        stimuli.setText(Stim)
        prompt.setSound(question, secs=1.0, hamming=True)
        prompt.setVolume(1.0, log=False)
        test_beep1.setSound('1300', secs=.245, hamming=True)
        test_beep1.setVolume(1.0, log=False)
        test_beep2.setSound('1300', secs=.245, hamming=True)
        test_beep2.setVolume(1.0, log=False)
        test_beep3.setSound('1500', secs=.245, hamming=True)
        test_beep3.setVolume(1.0, log=False)
        test_pause_key.keys = []
        test_pause_key.rt = []
        _test_pause_key_allKeys = []
        # keep track of which components have finished
        trialComponents = [stimuli, prompt, blank, test_beep1, test_beep2, test_beep3, test_pause_key]
        for thisComponent in trialComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "trial" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *stimuli* updates
            if stimuli.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                stimuli.frameNStart = frameN  # exact frame index
                stimuli.tStart = t  # local t and not account for scr refresh
                stimuli.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(stimuli, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'stimuli.started')
                stimuli.setAutoDraw(True)
            if stimuli.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > stimuli.tStartRefresh + .5-frameTolerance:
                    # keep track of stop time/frame for later
                    stimuli.tStop = t  # not accounting for scr refresh
                    stimuli.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'stimuli.stopped')
                    stimuli.setAutoDraw(False)
            # start/stop prompt
            if prompt.status == NOT_STARTED and tThisFlip >= .5-frameTolerance:
                # keep track of start time/frame for later
                prompt.frameNStart = frameN  # exact frame index
                prompt.tStart = t  # local t and not account for scr refresh
                prompt.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('prompt.started', tThisFlipGlobal)
                prompt.play(when=win)  # sync with win flip
            if prompt.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > prompt.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    prompt.tStop = t  # not accounting for scr refresh
                    prompt.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'prompt.stopped')
                    prompt.stop()
            
            # *blank* updates
            if blank.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                # keep track of start time/frame for later
                blank.frameNStart = frameN  # exact frame index
                blank.tStart = t  # local t and not account for scr refresh
                blank.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(blank, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'blank.started')
                blank.setAutoDraw(True)
            if blank.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > blank.tStartRefresh + 5-frameTolerance:
                    # keep track of stop time/frame for later
                    blank.tStop = t  # not accounting for scr refresh
                    blank.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'blank.stopped')
                    blank.setAutoDraw(False)
            # start/stop test_beep1
            if test_beep1.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                # keep track of start time/frame for later
                test_beep1.frameNStart = frameN  # exact frame index
                test_beep1.tStart = t  # local t and not account for scr refresh
                test_beep1.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('test_beep1.started', tThisFlipGlobal)
                test_beep1.play(when=win)  # sync with win flip
            if test_beep1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > test_beep1.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    test_beep1.tStop = t  # not accounting for scr refresh
                    test_beep1.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'test_beep1.stopped')
                    test_beep1.stop()
            # start/stop test_beep2
            if test_beep2.status == NOT_STARTED and tThisFlip >= 3.5-frameTolerance:
                # keep track of start time/frame for later
                test_beep2.frameNStart = frameN  # exact frame index
                test_beep2.tStart = t  # local t and not account for scr refresh
                test_beep2.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('test_beep2.started', tThisFlipGlobal)
                test_beep2.play(when=win)  # sync with win flip
            if test_beep2.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > test_beep2.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    test_beep2.tStop = t  # not accounting for scr refresh
                    test_beep2.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'test_beep2.stopped')
                    test_beep2.stop()
            # start/stop test_beep3
            if test_beep3.status == NOT_STARTED and tThisFlip >= Latency_s-frameTolerance:
                # keep track of start time/frame for later
                test_beep3.frameNStart = frameN  # exact frame index
                test_beep3.tStart = t  # local t and not account for scr refresh
                test_beep3.tStartRefresh = tThisFlipGlobal  # on global time
                # add timestamp to datafile
                thisExp.addData('test_beep3.started', tThisFlipGlobal)
                test_beep3.play(when=win)  # sync with win flip
            if test_beep3.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > test_beep3.tStartRefresh + .245-frameTolerance:
                    # keep track of stop time/frame for later
                    test_beep3.tStop = t  # not accounting for scr refresh
                    test_beep3.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'test_beep3.stopped')
                    test_beep3.stop()
            
            # *test_pause_key* updates
            waitOnFlip = False
            if test_pause_key.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                test_pause_key.frameNStart = frameN  # exact frame index
                test_pause_key.tStart = t  # local t and not account for scr refresh
                test_pause_key.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(test_pause_key, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'test_pause_key.started')
                test_pause_key.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(test_pause_key.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(test_pause_key.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if test_pause_key.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > test_pause_key.tStartRefresh + 6.5-frameTolerance:
                    # keep track of stop time/frame for later
                    test_pause_key.tStop = t  # not accounting for scr refresh
                    test_pause_key.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'test_pause_key.stopped')
                    test_pause_key.status = FINISHED
            if test_pause_key.status == STARTED and not waitOnFlip:
                theseKeys = test_pause_key.getKeys(keyList=['space'], waitRelease=False)
                _test_pause_key_allKeys.extend(theseKeys)
                if len(_test_pause_key_allKeys):
                    test_pause_key.keys = _test_pause_key_allKeys[-1].name  # just the last key pressed
                    test_pause_key.rt = _test_pause_key_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in trialComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "trial" ---
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        prompt.stop()  # ensure sound has stopped at end of routine
        test_beep1.stop()  # ensure sound has stopped at end of routine
        test_beep2.stop()  # ensure sound has stopped at end of routine
        test_beep3.stop()  # ensure sound has stopped at end of routine
        # check responses
        if test_pause_key.keys in ['', [], None]:  # No response was made
            test_pause_key.keys = None
        test_repeat.addData('test_pause_key.keys',test_pause_key.keys)
        if test_pause_key.keys != None:  # we had a response
            test_repeat.addData('test_pause_key.rt', test_pause_key.rt)
        # the Routine "trial" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "test_pause" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        end_test_pause_key.keys = []
        end_test_pause_key.rt = []
        _end_test_pause_key_allKeys = []
        # Run 'Begin Routine' code from test_pause_code
        if not test_pause_key.rt:
            continueRoutine = False
            test_repeat.finished = True
        # keep track of which components have finished
        test_pauseComponents = [test_pause_text, end_test_pause_key]
        for thisComponent in test_pauseComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "test_pause" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *test_pause_text* updates
            if test_pause_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                test_pause_text.frameNStart = frameN  # exact frame index
                test_pause_text.tStart = t  # local t and not account for scr refresh
                test_pause_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(test_pause_text, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'test_pause_text.started')
                test_pause_text.setAutoDraw(True)
            
            # *end_test_pause_key* updates
            waitOnFlip = False
            if end_test_pause_key.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                end_test_pause_key.frameNStart = frameN  # exact frame index
                end_test_pause_key.tStart = t  # local t and not account for scr refresh
                end_test_pause_key.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(end_test_pause_key, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'end_test_pause_key.started')
                end_test_pause_key.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(end_test_pause_key.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(end_test_pause_key.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if end_test_pause_key.status == STARTED and not waitOnFlip:
                theseKeys = end_test_pause_key.getKeys(keyList=['space'], waitRelease=False)
                _end_test_pause_key_allKeys.extend(theseKeys)
                if len(_end_test_pause_key_allKeys):
                    end_test_pause_key.keys = _end_test_pause_key_allKeys[-1].name  # just the last key pressed
                    end_test_pause_key.rt = _end_test_pause_key_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in test_pauseComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "test_pause" ---
        for thisComponent in test_pauseComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if end_test_pause_key.keys in ['', [], None]:  # No response was made
            end_test_pause_key.keys = None
        test_repeat.addData('end_test_pause_key.keys',end_test_pause_key.keys)
        if end_test_pause_key.keys != None:  # we had a response
            test_repeat.addData('end_test_pause_key.rt', end_test_pause_key.rt)
        # the Routine "test_pause" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # --- Prepare to start Routine "rest" ---
        continueRoutine = True
        routineForceEnded = False
        # update component parameters for each repeat
        # Run 'Begin Routine' code from rest_code
        #trialCount=trialCount+1
        
        if expInfo['language'] == 'nynorsk':
        #    rest_message = 'you have completed' + test_trials.length +' of' + test_trials.nReps +' trials!'
            rest_message = 'No kan du kvile litt.\n\n Trykk på MELLOMROMSTASTEN når du er klar til å fortsette.\n\n Du er ferdig med ' + str((test_trials.thisN+1)//15)  +' av 13 bolkar'
        elif expInfo['language'] == 'bokmål':
            rest_message = 'Nå kan du hvile litt.\n\n Trykk på MELLOMROMSTASTEN når du er klar til å fortsette.\n\n Du er ferdig med ' + str((test_trials.thisN + 1)//15)  +' av 13 bolker'
        
        breakTrials = [14,29,44,59,74,89,104,119,134,149,164,179]
        
        if test_trials.thisN not in breakTrials:
            continueRoutine = False
        rest_text.setText(rest_message)
        rest_key_resp.keys = []
        rest_key_resp.rt = []
        _rest_key_resp_allKeys = []
        # keep track of which components have finished
        restComponents = [rest_text, rest_key_resp]
        for thisComponent in restComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "rest" ---
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # Run 'Each Frame' code from rest_code
            #if trialCount not in breakTrials:
            #    continueRoutine = False
            
            # *rest_text* updates
            if rest_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                rest_text.frameNStart = frameN  # exact frame index
                rest_text.tStart = t  # local t and not account for scr refresh
                rest_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(rest_text, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'rest_text.started')
                rest_text.setAutoDraw(True)
            
            # *rest_key_resp* updates
            waitOnFlip = False
            if rest_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                rest_key_resp.frameNStart = frameN  # exact frame index
                rest_key_resp.tStart = t  # local t and not account for scr refresh
                rest_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(rest_key_resp, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'rest_key_resp.started')
                rest_key_resp.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(rest_key_resp.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(rest_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if rest_key_resp.status == STARTED and not waitOnFlip:
                theseKeys = rest_key_resp.getKeys(keyList=['space'], waitRelease=False)
                _rest_key_resp_allKeys.extend(theseKeys)
                if len(_rest_key_resp_allKeys):
                    rest_key_resp.keys = _rest_key_resp_allKeys[-1].name  # just the last key pressed
                    rest_key_resp.rt = _rest_key_resp_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in restComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "rest" ---
        for thisComponent in restComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if rest_key_resp.keys in ['', [], None]:  # No response was made
            rest_key_resp.keys = None
        test_repeat.addData('rest_key_resp.keys',rest_key_resp.keys)
        if rest_key_resp.keys != None:  # we had a response
            test_repeat.addData('rest_key_resp.rt', rest_key_resp.rt)
        # the Routine "rest" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
    # completed 100.0 repeats of 'test_repeat'
    
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'test_trials'


# --- Prepare to start Routine "end" ---
continueRoutine = True
routineForceEnded = False
# update component parameters for each repeat
# Run 'Begin Routine' code from end_text_code
if expInfo['language'] == 'nynorsk':
    end_message = 'Takk for deltakinga di!'
elif expInfo['language'] == 'bokmål':
    end_message = 'Takk for deltakelsen din!'
end_text.setText(end_message)
end_key_resp.keys = []
end_key_resp.rt = []
_end_key_resp_allKeys = []
# keep track of which components have finished
endComponents = [end_text, end_key_resp]
for thisComponent in endComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "end" ---
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *end_text* updates
    if end_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        end_text.frameNStart = frameN  # exact frame index
        end_text.tStart = t  # local t and not account for scr refresh
        end_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(end_text, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'end_text.started')
        end_text.setAutoDraw(True)
    
    # *end_key_resp* updates
    waitOnFlip = False
    if end_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        end_key_resp.frameNStart = frameN  # exact frame index
        end_key_resp.tStart = t  # local t and not account for scr refresh
        end_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(end_key_resp, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'end_key_resp.started')
        end_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(end_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(end_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if end_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = end_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _end_key_resp_allKeys.extend(theseKeys)
        if len(_end_key_resp_allKeys):
            end_key_resp.keys = _end_key_resp_allKeys[-1].name  # just the last key pressed
            end_key_resp.rt = _end_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in endComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "end" ---
for thisComponent in endComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if end_key_resp.keys in ['', [], None]:  # No response was made
    end_key_resp.keys = None
thisExp.addData('end_key_resp.keys',end_key_resp.keys)
if end_key_resp.keys != None:  # we had a response
    thisExp.addData('end_key_resp.rt', end_key_resp.rt)
thisExp.nextEntry()
# the Routine "end" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
